<template>
  <ModalsBase
    :id="id"
    title="Create a project"
    :footer="true"
    :header="true"
    :ok-disabled="!formIsValid"
    ok-title="Create"
    bodyclass="p-0"
    @ok="createProject()"
  >
    <template #body>
      <div class="p-3">
        <div class="mb-3">
          <div class="subheader mb-2">Title</div>
          <b-form-input
            v-model.trim="$v.title.$model"
            data-cy="input-title-create-project"
            placeholder="Title for the project"
            class="mb-1"
            :class="{ 'is-invalid': $v.title.$error }"
          >
          </b-form-input>
          <!-- title input errors -->
          <template v-if="$v.title.$dirty">
            <div
              v-if="!$v.title.required"
              data-cy="error-title-create-project"
              class="text-red small"
            >
              Title is required
            </div>
          </template>
          <!-- /title input errors -->
        </div>
        <div>
          <div class="subheader mb-2">Description</div>
          <textarea
            v-model.trim="$v.description.$model"
            data-cy="input-description-create-project"
            class="form-control textarea-project-description"
            placeholder="Description for the project"
            rows="4"
            maxlength="200"
            :class="{ 'is-invalid': $v.description.$error }"
          >
          </textarea>
          <!-- description input errors -->
          <template v-if="$v.description.$dirty">
            <div
              v-if="!$v.description.required"
              data-cy="error-title-create-project"
              class="text-red small"
            >
              Description required
            </div>
            <div
              v-if="!$v.description.maxLength"
              data-cy="error-long-description-create-project"
              class="text-red small"
            >
              Description should be shorter than 200 characters
            </div>
          </template>
          <!-- description input errors -->
        </div>
      </div>
    </template>
  </ModalsBase>
</template>
<script>
import { required, maxLength } from 'vuelidate/lib/validators';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  props: {
    id: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      title: '',
      description: '',
    };
  },
  computed: {
    formIsValid() {
      return !this.$v.$invalid;
    },
  },
  methods: {
    async createProject() {
      try {
        const projectId = await this.$nuxt.context.store.dispatch(
          'projects/createProject',
          {
            title: this.title,
            description: this.description,
          }
        );
        this.title = '';
        this.description = '';
        this.$v.$reset();
        this.$router.push({
          path: `/projects/${projectId}/view`,
        });
      } catch (error) {
        this.showErrorNotification('Error creating project');
      }
    },
  },
  validations: {
    title: {
      required,
    },
    description: {
      required,
      maxLength: maxLength(200),
    },
  },
};
</script>
